/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#pragma once
#include "OkTypes.h"

class OkAddress {
public:
    OkAddress();
    OkAddress(void *p);

    OkAddress operator+(u_short offset);
    OkAddress operator+(u_int offset);
    OkAddress operator+(u_long offset);

    OkAddress operator-(u_short offset);
    OkAddress operator-(u_int offset);
    OkAddress operator-(u_long offset);

    void operator+=(u_short offset);
    void operator+=(u_int offset);
    void operator+=(u_long offset);

    void operator-=(u_short offset);
    void operator-=(u_int offset);
    void operator-=(u_long offset);

    OkBool operator==(const OkAddress& r);
    OkBool operator!=(const OkAddress& r);
    OkBool operator<(const OkAddress& r);
    OkBool operator<=(const OkAddress& r);
    OkBool operator>(const OkAddress& r);
    OkBool operator>=(const OkAddress& r);

    operator void*();

protected:
    char * ptr;
};
