/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
///////////////////////////////////////////////////////////////////
// OkImageView.h --
///////////////////////////////////////////////////////////////////
#ifndef OKIMAGEVIEW_H
#define OKIMAGEVIEW_H

#include <Vk/VkComponent.h>
#include <il/ilGenericImgFile.h>
#include <il/ilGLXConfig.h>
#include <il/ilDisplay.h>


class OkImageView : public VkComponent {

 private:
  
  ilFileImg*	_imgFile;
  ilDisplay*	_imgDisplay;

  static void redrawCB( Widget, XtPointer obj, XtPointer ) 
	{ ((OkImageView*)obj)->redraw(); }
  static void resizeCB( Widget, XtPointer obj, XtPointer ) 
	{ ((OkImageView*)obj)->redraw(); }

 public:
  
  OkImageView( const char* name, Widget parent );
  virtual ~OkImageView();

  void open( const char* fileName );
  void close();

  virtual void redraw( Boolean newImgFile=FALSE );

  ilFileImg* imgFile() 		{ return _imgFile; }
  ilDisplay* imgDisplay() 	{ return _imgDisplay; }

};


#endif
