/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
///////////////////////////////////////////////////
// OkLabel.h
///////////////////////////////////////////////////
#ifndef OKLABEL_H
#define OKLABEL_H

#include "OkComponent.h"

#ifdef USE_GADGET
#include <Xm/LabelG.h>
#else
#include <Xm/Label.h>
#endif

class OkLabel : public OkComponent {

 private:
  OkCompoundString _s;

 public:
  OkLabel( const char* name ) : OkComponent( name ) {}
  OkLabel( const char* name, Widget parent,
		ArgList list=NULL, Cardinal count=0 ) :
    OkComponent( name ) 
  {
#ifdef USE_GADGET
    _baseWidget = XmCreateLabelGadget( parent, _name, list, count );
#else
    _baseWidget = XmCreateLabel( parent, _name, list, count );
#endif
    installDestroyHandler();
  }
  virtual ~OkLabel() {}
  virtual const char* className() { return "OkLabel"; }

  void setLabelString( const char* s ) 
  { 
    XtVaSetValues( _baseWidget, 
      XmNlabelString, (XmString) OkCompoundString( s ), 
      NULL ); 
  }
  const char* getLabelString() const 
  {
    XtVaGetValues( _baseWidget, XmNlabelString, &_s, NULL );
    return _s;
  }
    

};

#endif
