/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/////////////////////////////////////////////////////////////
// OkLabeledComponent.h	--
//
// Just like in Doug's book, except it takes any class.
/////////////////////////////////////////////////////////////
#ifndef OKLABELEDCOMPONENT_H
#define OKLABELEDCOMPONENT_H

#pragma once

#include <Vk/VkComponent.h>

template <class T>
class OkLabeledComponent : public VkComponent {

 public:
  enum Orientation { HORIZONTAL, VERTICAL };
  
 private:

  static String _defaultResources[];

  Widget _label;
  T 	*_component;

 public:
  OkLabeledComponent( const char* name, Widget parent, 
			Orientation ornt=HORIZONTAL );
  virtual ~OkLabeledComponent();
  virtual const char* className() { return "OkLabeledComponent"; }

  Widget label() 	{ return _label; }
  T* component()   	{ return _component; }

  // Don't use this stupid name anymore.
  T* t()   		{ return component(); }

};


#endif
