/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#pragma once

#include "OkTextPat.h"

// Class for doing regular expression searches. The relevant routines
// from libPW are included in this library.

class OkRegEx : public OkTextPat {
public:

    OkRegEx(char * pattern);
    OkRegEx(OkStr &);
    OkRegEx(OkRegEx& a)
	{ regcmp_stuff = (char*) new char[strlen(a.regcmp_stuff)+1]; };
    ~OkRegEx();

    // Determine whether this is a valid regular expression.
    int isValid() { return regcmp_stuff != 0; }

protected:
    char * regcmp_stuff;

    // If the regular expression is invalid, the searching routines
    // act as if it could not be found, except that
    // findBuffer and bracketBuffer return -2 instead of -1.
    virtual int findBuffer(char*, u_int) ;
    virtual int findEndBuffer(char*, u_int) ;
    virtual void bracketBuffer(char*, u_int, int&, int&) ;
};

// Tell whether this string contains any special regular
// expression characters.
extern OkBool OkIsRegEx(char *);
