/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#pragma once

#include "OkTextPat.h"

// Class for doing super-linear searches. See OkSLinearPat.c++ for details.

class OkSLinearPat : public OkTextPat {
public:
    OkSLinearPat(char *pattern, u_int patternLength = 0);
    OkSLinearPat(OkStr &s);
    virtual ~OkSLinearPat();

protected:
    u_int	skip_table[OkNUMCHARS];
    char*	pattern;
    u_int	patternLength;

    void constructor(char*, u_int);

    virtual int findBuffer(char*, u_int);
    virtual int findEndBuffer(char*, u_int);
    virtual void bracketBuffer(char*, u_int, int&, int&);
};

