/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
///////////////////////////////////////////////
// OkText.h	--
///////////////////////////////////////////////
#ifndef OKTEXT_H
#define OKTEXT_H

#include "OkComponent.h"

#include <Xm/Text.h>


class OkText : public OkComponent {

 private:
  CALLBACKSTUB(OkText,activate);
  CALLBACKSTUB(OkText,modifyVerify);
  CALLBACKSTUB(OkText,valueChanged);

 protected:
  void addCallbacks();

 public:
  OkText( const char* name );
  OkText( const char* name, Widget parent, 
			ArgList list=NULL, Cardinal count=0 );
  virtual ~OkText() {}
  virtual const char* className() { return "OkText"; }

  virtual void activate() {}
  virtual void modifyVerify() {}
  virtual void valueChanged() {}

  const char* getValue() const
    { return XmTextGetString( _baseWidget ); }
  void setValue( const char* value ) 
    { XmTextSetString( _baseWidget, (char *) value ); }


  XmTextPosition getInsertionPosition() const
    { return XmTextGetInsertionPosition( _baseWidget ); }

  void insert( const char* string, XmTextPosition pos= -1 )
    { XmTextInsert( _baseWidget, (pos>=0 ? pos : getInsertionPosition()), 
		    (char *) string ); }
};

#endif
