/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
///////////////////////////////////////////////////
// OkToggleButton.h
///////////////////////////////////////////////////
#ifndef OKTOGGLEBUTTON_H
#define OKTOGGLEBUTTON_H

#include "OkLabel.h"

class OkToggleButton : public OkLabel {

 private:
  CALLBACKSTUB(OkToggleButton,valueChanged);
  CALLBACKSTUB(OkToggleButton,arm);
  CALLBACKSTUB(OkToggleButton,disarm);

  void valueChanged();

 protected:
  virtual void valueChanged( Boolean /*value*/ ) {}
  virtual void arm() {}
  virtual void disarm() {}


 public:
  OkToggleButton( const char* name, Widget parent,
		ArgList list=NULL, Cardinal count=0 );
  virtual ~OkToggleButton() {}
  virtual const char* className() { return "OkToggleButton"; }

  void setValue( Boolean );
  Boolean getValue();

};

#endif
