/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#pragma once

#include "string.h"
#include "assert.h"
#include "stdio.h"
#include "new.h"
#include "libc.h"
#include "limits.h"


typedef	unsigned char	u_char;
typedef	unsigned short	u_short;
typedef	unsigned int	u_int;
typedef	unsigned long	u_long;

// Boolean type
typedef unsigned char OkBool;
#undef	TRUE
#define	TRUE	((OkBool)1)
#undef	FALSE
#define	FALSE	((OkBool)0)

// minimum of two numbers
inline int Okmin(int a, int b)		{ return (a < b) ? a : b; }
inline u_long Okmin(u_long a, u_long b)	{ return (a < b) ? a : b; }
inline u_int Okmin(u_int a, u_int b)	{ return (a < b) ? a : b; }

// maximum of two numbers
inline int Okmax(int a, int b)		{ return (a > b) ? a : b; }
inline u_long Okmax(u_long a, u_long b)	{ return (a > b) ? a : b; }
inline u_int Okmax(u_int a, u_int b)	{ return (a > b) ? a : b; }

// absolute value of two numbers
inline int Okabs(int a)			{ return (a < 0) ? -a : a; }

#define __enddef__

// Number of characters that can be represented in a single "char".
// Usually 256.
#define OkNUMCHARS (1<<CHAR_BIT)

// This should be set to 1 if the sizeof(int) == sizeof(long).
// It should be set to 0 if the sizeof(int) == sizeof(short).
#if INT_MAX == LONG_MAX
#define OkINTISLONG 1
#else
#define OkINTISLONG 0
#endif

